OptionsPanel = class(Turbine.UI.Control);

local Constants =
{
	Size =
	{
		Width = 400,
		Height = 120
	},
	Padding =
	{
		Left = 10,
		Top = 10
	},
	RowWidth = 180,
	LineSpacing = 4
}

function OptionsPanel:Constructor()
	Turbine.UI.Control.Constructor(self);

    self:SetSize(Constants.Size.Height, Constants.Size.Width);
	
	local top = Constants.Padding.Top;
	local left = Constants.Padding.Left;
	
    self.EnabledCheckbox = Turbine.UI.Lotro.CheckBox();
    self.EnabledCheckbox:SetParent(self);
    self.EnabledCheckbox:SetFont(Globals.Fonts.Label);
    self.EnabledCheckbox:SetForeColor(Globals.Colours.Label);
    self.EnabledCheckbox:SetSize(Constants.RowWidth, Globals.Sizes.Label.Height);
    self.EnabledCheckbox:SetPosition(left, top);
    self.EnabledCheckbox:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
    self.EnabledCheckbox:SetText(Strings["enable_babble"]);
	self.EnabledCheckbox.UpdateStatus = true;
	self.EnabledCheckbox.CheckedChanged = function(sender, args)
		if self.EnabledCheckbox.UpdateStatus then
			BabbleHelper:UpdateStatus(self.EnabledCheckbox:IsChecked());
		else
			self.EnabledCheckbox.UpdateStatus = true;
		end
	end
	
	top = top + self.EnabledCheckbox:GetHeight() + Constants.LineSpacing * 2;
	
	local buttonAdjuster = UIOptions["wide_options_button"] and 2 or 1;
	
	local listFilterButton = CreateButton(self, buttonAdjuster);
	listFilterButton:SetPosition(left, top);
	listFilterButton:SetText(Strings["list_filters"])
	listFilterButton.Click = function(sender, args)
		BabbleHelper:ListFilters();
	end
	
	top = top + listFilterButton:GetHeight() + Constants.LineSpacing;
	
	local settingsButton = CreateButton(self, buttonAdjuster);
	settingsButton:SetPosition(left, top);
	settingsButton:SetText(Strings["edit_settings"])
	settingsButton.Click = function(sender, args)
		SettingsWindow:Show();
	end
end

function OptionsPanel:EnableCheckbox(enabled)
	self.EnabledCheckbox.UpdateStatus = false;
	self.EnabledCheckbox:SetChecked(enabled);
end