function KeyDownActions(self, args)
	if args.Action == 268435635 then
		if not self.UIHidden then
			self.UIHidden = true;
			self.WasVisible = self:IsVisible();
			if self.WasVisible then
				self:SetVisible(false);					
			end
		else
			if self.WasVisible then
				self:SetVisible(true);
			end
			self.UIHidden = false;
		end
	elseif args.Action == 145 and (self.AlwaysVisible == nil or not self.AlwaysVisible) then
		if self:IsVisible() then
			self.ReopenOnToggle = true;
		end
		self:SetVisible(false);
	end
end

function CreateButton(parent, widthAdjuster)
	local button = Turbine.UI.Lotro.Button();
	button:SetParent(parent);
	if widthAdjuster == 2 then
		button:SetSize(Globals.Sizes.ExtraWideButton.Width, Globals.Sizes.ExtraWideButton.Height);
	elseif widthAdjuster == 1 then
		button:SetSize(Globals.Sizes.WideButton.Width, Globals.Sizes.WideButton.Height);
	elseif widthAdjuster == -1 then
		button:SetSize(Globals.Sizes.NarrowButton.Width, Globals.Sizes.NarrowButton.Height);
	else
		button:SetSize(Globals.Sizes.Button.Width, Globals.Sizes.Button.Height);
	end
	button:SetText("");
	
	return button;
end

function CreateTextBox(parent)
	local textBox = Turbine.UI.Lotro.TextBox();
	textBox:SetParent(parent);
	textBox:SetFont(Globals.Fonts.TextBox);
	textBox:SetSize(Globals.Sizes.TextBox.Width, Globals.Sizes.TextBox.Height);
	textBox:SetForeColor(Globals.Colours.TextBox);
	textBox:SetBackColor(Globals.BackgroundColours.TextBox);
	textBox:SetText("");

	return textBox;
end

function CreateLabel(parent, multiline)
	local label = Turbine.UI.Label();
	label:SetParent(parent);
	label:SetForeColor(Globals.Colours.Label);
	label:SetFont(Globals.Fonts.Label);
	label:SetHeight(Globals.Sizes.Label.Height);
	label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	label:SetMultiline(multiline or false);
	label:SetText("");

	return label;
end

function CreateCheckBox(parent, left, top, width, height, text)
	local checkBox = Turbine.UI.Lotro.CheckBox();
	checkBox:SetParent(parent);
	if left ~= nil and top ~= nil then
		checkBox:SetPosition(left, top);
	end
	if width ~= nil and height ~= nil then
		checkBox:SetSize(width, height);
	else
		checkBox:SetSize(Globals.Sizes.CheckBoxOnly.Width, Globals.Sizes.CheckBoxOnly.Height);
	end
	checkBox:SetForeColor(Globals.Colours.Label);
	checkBox:SetFont(Globals.Fonts.Label);
	if text ~= nil then
		checkBox:SetText(" " .. text);
	else
		checkBox:SetText("");
	end
	checkBox:SetChecked(false);
	
	return checkBox;
end

function CreateDropdown(parent, left, top, width, height, dropdownHeight)
	local dropdown = DropdownList(parent);
	
	dropdown:SetBorderColor(Globals.BorderColours.ListBox);
	dropdown:SetBackColor(Globals.BackgroundColours.ListBox);	
	dropdown:SetForeColor(Globals.Colours.ListBox);	
	dropdown:SetFont(Globals.Fonts.ListBox);
	if width ~= nil and height ~= nil then
		dropdown:SetSize(width, height, dropdownHeight);
	end
	if left ~= nil and top ~= nil then
		dropdown:SetPosition(left, top);
	end

	return dropdown;
end
